;;
;;  TOPPERS Software
;;      Toyohashi Open Platform for Embedded Real-Time Systems
;; 
;;  Copyright (C) 2010 by TAKUYA
;;              Embedded and Real-Time Systems Laboratory
;;              Graduate School of Information Science, Nagoya Univ., JAPAN
;; 
;;  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
;;  ܥեȥѤΤޤࡥʲƱˤѡʣ
;;  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
;;  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
;;      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
;;      ˴ޤޤƤ뤳ȡ
;;  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
;;      ѤǤǺۤˤϡۤȼɥȡ
;;      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
;;      ̵ݾڵǺܤ뤳ȡ
;;  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
;;      ѤǤʤǺۤˤϡΤ줫ξ
;;      ȡ
;;    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
;;        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
;;    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
;;        𤹤뤳ȡ
;;  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
;;      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
;;      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
;;      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
;;      դ뤳ȡ
;; 
;;  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
;;  TOPPERSץȤϡܥեȥ˴ؤơλŪ
;;  ФŬޤơʤݾڤԤʤޤܥեȥ
;;  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
;;  Ǥʤ
;; 
;; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;  tf-mode for emacs
;;
;; 
;;  ˡ
;;   .emacs ɲä롥
;;  
;;  (setq load-path (append '("ե֤") load-path))
;;  (autoload 'tf-mode "tf-mode" nil t)
;;  (add-hook 'tf-mode-hook '(lambda () (font-lock-mode 1)))
;;  (setq auto-mode-alist (append '(
;;		("\\.tf$" . tf-mode)) auto-mode-alist))
;; 

;; 
;; ʸơ֥
;;

(defvar tf-mode-syntax-table nil
  "Syntax table in use in TF-mode buffers.")

(if tf-mode-syntax-table
    ()
  (setq tf-mode-syntax-table (make-syntax-table)))

;;
;; ɤζĴɽ
;; 

(defvar tf-font-lock-defaults 
  (list 'tf-font-lock-keywords
	t
	nil
	nil
	'beginning-of-line
	))

(defconst tf-font-lock-keywords
  (list
   ;; 
   '("^\$[ \t].*"
     . font-lock-comment-face)
   ;; 湽¤
   '("\\([\$]\\)\\(IF\\|FOREACH\\|JOINEACH\\)\\([ \t]\\)" 
     . (2 font-lock-keyword-face))
   '("\\([\$]\\)\\(END\\|ELSE\\)\\([\$]\\)"
     . (2 font-lock-keyword-face))
   '("\\([\$]\\)\\(FUNCTION\\|FILE\\|INCLUDE\\)\\([ \t]\\)"
     . (2 font-lock-builtin-face))
   '("\\([\$]\\)\\(ERROR\\|WORNING\\)\\([ \t\$]\\)"
     . (2 font-lock-warning-face))
   '("\\([\$]\\)\\(SPC\\|TAB\\|NL\\|ARGC\\|ARGV\\|RESULT\\)\\([\$]\\)"
     . (2 font-lock-string-face))
   '("\\([\"]\\)\\([^\"]\\)*\\([\"]\\)"
     . font-lock-string-face)
   '("\\([\']\\)\\([^\']\\)*\\([\']\\)"
     . font-lock-string-face)
   '("\\([ \t!@\$~\+\*^\(=,<>%|-]\\)\\(LENGTH\\|EQ\\|ALT\\|SORT\\|ENVIRON\\|VALUE\\|CONCAT\\|APPEND\\|AT\\|_\\|FORMAT\\|FIND\\|RANGE\\|SYMBOL\\|PEEK\\|DUMP\\|TRACE\\|NOOP\\|BCOPY\\|ESCSTR\\|UNESCSTR\\|CALL\\|LSORT\\)\\([\(]\\)"
     . (2 font-lock-function-name-face))
   ))

;;
;; tf⡼ͭΥХ
;;

(defvar tf-mode-map
  (let ((tf-keymap (make-keymap)))
    ;; ֤򲡤testƤФ롣
    (define-key tf-keymap "\t"  'tf-indent-line)
    tf-keymap))


;;------------------------
;;
;;  ǥȤ˴ؤ
;;
;;------------------------

(defvar *tf-tab-always-indent* t)

(defvar *tf-block-beg-re*
  "[\$]\\(IF\\|FOREACH\\|JOINEACH\\|FUNCTION\\)[ ]")
(defvar *tf-block-mid-re*
  "\$ELSE[\$]")
(defvar *tf-block-end-re* "\$END[\$]")

(defvar *tf-indent-column* 4)

(defun tf-space-line ()
  "Ԥɤ"
  (save-excursion
    (beginning-of-line) ; (goto-bol)
    (looking-at "\\([ \t]*$\\|^\$[ \t]\\)")))

(defun tf-previous-line ()
  "ԤʤԤޤ"
  (catch 'tf-previous-line-loop
    (while (= (forward-line -1) 0)
      (unless (tf-space-line)
	(throw 'tf-previous-line-loop t)))))

(defun calc-tf-indent ()
  "ǥȤ"
  (let ((column 0) (curp (point)))
    (save-excursion
      ;ιԤĴ٤
      (when (tf-previous-line)
	(beginning-of-line) ;(goto-bol)
	(skip-chars-forward " \t")
	; ǥȿ
	(setq column (current-column))
	;(message-box (format nil "column1: ~D" column))
	(save-restriction
	  (narrow-to-region (progn (end-of-line) (point)) ;(goto-eol) (point))
			    (progn (beginning-of-line) (point))) ;(goto-bol) (point)))
	  (beginning-of-line)
	  (skip-chars-forward " \t")
	  ; ΤХǥȿ䤹
	  (cond
	   ((looking-at *tf-block-beg-re*)
	    (setq column (+ column *tf-indent-column*)))
	   ((looking-at *tf-block-mid-re*)
	    (setq column (+ column *tf-indent-column*)))
	  )
	)))
    ;(message-box (format nil "column2: ~D" column))
    ; ߤιԤĴ٤
    (save-excursion
      (save-restriction
	(narrow-to-region (progn (end-of-line) (point)) ;(goto-eol) (point))
			  (progn (beginning-of-line) (point))) ;(goto-bol) (point)))
	(beginning-of-line) ; (goto-bol)
	(skip-chars-forward " \t")
	; ĤΤХǥȿ򸺤餹
	(cond
	 ((looking-at *tf-block-end-re*)
	  (setq column (- column *tf-indent-column*)))
	 ((looking-at *tf-block-mid-re*)
	  (setq column (- column *tf-indent-column*)))
	)))
    column
  ))

(defun tf-not-comment-line ()
  (save-excursion
    (progn
      (beginning-of-line)
      (if (looking-at "^\$[ \t]")
	  nil
	  t
	  )
      )
    ))

(defun tf-indent-line ()
  (interactive "*")
  (if (or (not (interactive-p))
	  *tf-tab-always-indent*
	  (save-excursion
	    (skip-chars-backward " \t")
	    (bolp)))
    (if (tf-not-comment-line) ;; ȹԤǤʤм¹Ԥ
      ; Ѥ
      (let ((column (calc-tf-indent)))
	(when (integerp column)
	  (save-excursion
	    (beginning-of-line) ;(goto-bol)
	    (delete-region (point)
			   (progn
			     (skip-chars-forward " \t")
			     (point)))
	    (indent-to column)))
	(if (and (bolp) column)
	    (skip-chars-forward " \t")))
	 )
    (insert "\t"))
  t)

;;
;; tf⡼ɥᥤؿ
;;

(defun tf-mode ()
  ""
  (interactive)
  (kill-all-local-variables)
  (set-syntax-table tf-mode-syntax-table)
  (setq case-fold-search nil)
  (use-local-map tf-mode-map)
  (setq mode-name "tf")
  (make-local-variable 'font-lock-defaults)
  (setq font-lock-defaults tf-font-lock-defaults)
  (set (make-local-variable 'indent-line-function) 'tf-indent-line)
  (run-hooks 'tf-mode-hook))

;; -------------------
;;
;;  $END$бõ
;;
;; -------------------

;; бõɽ
(defvar *tf-block-keyword* "[\$]\\(IF[ \t]\\|FOREACH[ \t]\\|JOINEACH[ \t]\\|FUNCTION[ \t]\\|END[\$]\\)")
(defvar *tf-block-tag* 'tf-block)

(defvar tf-block-highlight-face 'highlight)

(defvar tf-block-highlight-overlay nil)

(defun tf-block-get-line-start-pos ()
  (save-excursion
    (let ((xor '(lambda (a b) (and (or a b) (not (and a b)))))
          (point (point))
          (count 0))
      (while (and (not (funcall xor (bobp) (eolp)))
                  (> point (point-min)))
        (setq point (1- point))
        (goto-char (1- (point))))
      ;; delete linefeed of start point.
      (when (and (eolp) (>= (point-max) (1+ point)))
        (setq point (1+ point)))
      point)))

(defun tf-block-get-line-end-pos ()
  (save-excursion
    (let ((xor '(lambda (a b) (and (or a b) (not (and a b)))))
          (point (point)))
      (while (and (not (funcall xor (eobp) (eolp)))
                  (>= (point-max) point))
        (setq point (1+ point))
        (goto-char (1+ (point))))
      point)))

;; ϥ饤Ȥ򸵤᤹
(defun tf-block-highlight-done ()
  (remove-hook 'pre-command-hook 'tf-block-highlight-done)
  (if tf-block-highlight-overlay
      (delete-overlay tf-block-highlight-overlay)))

;; ϥ饤ȡʥХ쥤
(defun tf-block-do-highlight (start end)
  (if tf-block-highlight-overlay
      (move-overlay tf-block-highlight-overlay start end)
    (setq tf-block-highlight-overlay (make-overlay start end)))
  (overlay-put tf-block-highlight-overlay
	       'face tf-block-highlight-face)
  (add-hook 'pre-command-hook 'tf-block-highlight-done))

(defun tf-block-hook ()
  (progn
    (if (string-match "tf" mode-name) ;; tf-modeΤȤ
	(let (now)
	  (save-excursion
	    (progn
	      (setq now (point))
	      (if (string-match "\$END\$" (buffer-substring (- now 5) (- now 1))) ;; $END$θ˥
		  (progn
		    (goto-char now)
		    (do-tf-block) ;; θƤӽФ
		    )
		)
	      )
	    )
	  )
      )
    )
  )

(defun do-tf-block ()
  (let (from to end_depth line_no line_string tmp_string now)
    (save-excursion
      (setq from (point))
      (backward-char 1)
      (if t ;(re-search-backward *tf-block-keyword*) ;(scan-buffer *tf-block-keyword* :reverse t :regexp t)
	  (progn
	    (setq end_depth 1) ;; $END$ο
	    (while (> end_depth 0) ;; $END$бĤޤ
	      (progn
		(if (re-search-backward *tf-block-keyword* nil t);(scan-buffer *tf-block-keyword* :reverse t :regexp t :no-dup t)
		    (progn
		      (setq tmp_string (match-string 0))
		      (setq now (point))
		      (beginning-of-line)
		      (if (not (string-match "^$[ \t]" (buffer-substring (point) (+ (point) 2)))) ;; ȥ椫å
			  (progn
			    (goto-char now)
			    (if (string-match "[\$]END[\$]" tmp_string) ;; $END$Ĥä
				 (setq end_depth (+ end_depth 1)) ;; +1
			      (progn ;; $END$ʳĤä
			  	 (setq end_depth (- end_depth 1)) ;; -1
				  ))
			    )
			)
		      )
		  (setq end_depth -1) ;; $END$бʤ
		  )))
	    (if (= end_depth 0) ;; $END$бä
		(progn
		  (let ((slinep 0) (elinep 0))
		    (save-excursion
		      (setq slinep (tf-block-get-line-start-pos)
			    elinep (tf-block-get-line-end-pos)))
		    ;; display line contents to minibuffer
		    (message "%d: %s" (1+ (count-lines (point-min) slinep))
			       (buffer-substring slinep elinep))
		    ;; do overlay.
		    (tf-block-do-highlight slinep elinep))
		  )
	      (message "ʤ") ;; $END$бʤä
	      )
	    )
	)
      )
    )
  )


(add-hook 'post-command-hook 'tf-block-hook) ;; post-command-hookɲ
